package
{
	import flash.display.Bitmap;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/end.png")] public static var ImgEnd:Class;
		
		[Embed(source = "data/Levels/level1.txt", mimeType = "application/octet-stream")] public static var TxtLevel1:Class;		
		[Embed(source = "data/Levels/level2.txt", mimeType = "application/octet-stream")] public static var TxtLevel2:Class;		
		[Embed(source = "data/Levels/level3.txt", mimeType = "application/octet-stream")] public static var TxtLevel3:Class;		
		[Embed(source = "data/Levels/level4.txt", mimeType = "application/octet-stream")] public static var TxtLevel4:Class;		
		[Embed(source = "data/Levels/level5.txt", mimeType = "application/octet-stream")] public static var TxtLevel5:Class;		
		[Embed(source = "data/Levels/level6.txt", mimeType = "application/octet-stream")] public static var TxtLevel6:Class;		
		[Embed(source = "data/Levels/level7.txt", mimeType = "application/octet-stream")] public static var TxtLevel7:Class;		
		[Embed(source = "data/Levels/level8.txt", mimeType = "application/octet-stream")] public static var TxtLevel8:Class;		
		[Embed(source = "data/Levels/level9.txt", mimeType = "application/octet-stream")] public static var TxtLevel9:Class;		
		[Embed(source = "data/Levels/level10.txt", mimeType = "application/octet-stream")] public static var TxtLevel10:Class;		
		public static var size : int = 11;
		public static var innersize : int = 3;
		
		public var board:FlxGroup;
		
		public var box:Box;
		public var initbox:Box;
		public var leftmargin:int=56;
		public var topmargin:int=16;
		
		public var won:Boolean;
		public var restarttext:FlxText;
		public var leveltext:FlxText;
		public var scoretext:FlxText;
		public var player:FlxSprite;
		public var end:FlxSprite;
		
		override public function create() : void
		{
			//FlxG.level=7;
		
			size=11;
			innersize=6;
			box = new Box(size);
			leftmargin=FlxG.width/2-19*(size/2);
			topmargin=FlxG.height/2-19*(size/2);
			
			
			won=false;
			super.create();
			
			var bg:FlxSprite = new FlxSprite(0,0,null);
			bg.createGraphic(FlxG.width,FlxG.height,0xff000000,false,"bg");
			this.add(bg);
			

			restarttext = new FlxText(0,0,FlxG.width,"press space to reset level");
			restarttext.alignment="right";
			restarttext.color=0xffff0000;			
			this.add(restarttext);

			
			scoretext = new FlxText(0,0,FlxG.width,"");
			scoretext.text = "moves : "+FlxG.score.toString();
			scoretext.color=0xffff0000;
			scoretext.alignment="left";
			this.add(scoretext);
			
			
			leveltext = new FlxText(0,FlxG.height-12,FlxG.width,"");
			leveltext.text = "level : "+(FlxG.level+1).toString();
			leveltext.color=0xffff0000;
			leveltext.alignment="left";
			this.add(leveltext);
			
	
			board = new FlxGroup();
			this.add(board);
			generateBoard();	
			generateBoxGraphics();			
		}
		
		public function generateBoxGraphics() : void
		{
			board.kill();
			this.defaultGroup.remove(board);
			board = new FlxGroup();
			for (var i:int=0;i<box.dat.length;i++)
			{
				for (var j:int=0;j<box.dat[i].length;j++)
				{
					var s:FlxSprite = new FlxSprite(leftmargin+19*i,topmargin+19*j);

					switch (box.dat[i][j])
					{
						case 0:
							s.createGraphic(19,19,0xff000000,false,"blacktile");
							s._pixels.fillRect(new Rectangle(1,1,17,17),0xff880000);
							s._pixels.fillRect(new Rectangle(2,2,15,15),0xff220000);
							s.resetHelpers();
							break;
						case 1:
							s.createGraphic(19,19,0xff000000,false,"whitetile");
							s._pixels.fillRect(new Rectangle(1,1,17,17),0xff880000);
							s._pixels.fillRect(new Rectangle(2,2,15,15),0xff220000);
							s._pixels.fillRect(new Rectangle(3,3,13,13),0xffff0000);
							s.resetHelpers();
							break;						
						case 2:
							s.createGraphic(19,19,0xff000000,false,"wall");
							break;
						//s.createGraphic(16,16,0xffffff00);
					}
					board.add(s);
				}
			}
			
			s = new FlxSprite(leftmargin+19*box.px+4,topmargin+19*box.py+4,null);
			s.createGraphic(19-8,19-8,0xffffffff,true,"playertile");
			board.add(s);
			player=s;
			
			
			s = new FlxSprite(leftmargin+19*box.ex,topmargin+19*box.ey,GameState.ImgEnd);
//			s.createGraphic(19-8,19-8,0xff00ffff,true,"endtile");
			board.add(s);
			end=s;
			
			this.add(board);			
		}
	
		public function generateBoard() : void
		{
			this.box = new Box(size);
		}
		public var t:Number;
		
		
		override public function update() : void
		{
			if (!won)
			{
				if (FlxG.keys.justPressed("UP"))
				{
					TryMoveBox(FlxSprite.UP);			
				}
				if (FlxG.keys.justPressed("RIGHT"))
				{
					TryMoveBox(FlxSprite.RIGHT);		
				}
				if (FlxG.keys.justPressed("DOWN"))
				{
					TryMoveBox(FlxSprite.DOWN);			
				}
				if (FlxG.keys.justPressed("LEFT"))
				{
					TryMoveBox(FlxSprite.LEFT);		
				}
				if (FlxG.keys.justPressed("SPACE"))
				{
					ResetBox();
				}
			}
			else
			{
				
				if (t>0)
				{
					t-=FlxG.elapsed;
					if (t<0)
					{
						FlxG.level++;
						if (FlxG.level<=7)
						{
							FlxG.state = new GameState();
						}
						else
						{
							FlxG.state = new CutsceneState();
						}
					}
				}
				
				if (FlxG.keys.justPressed("SPACE"))
				{
					s2.flicker(1);
					t=1;
				}				
			}
			
			super.update();
		}
		
		public function ResetBox():void
		{
			FlxG.state = new GameState();
			FlxG.play(TitleState.SndHeavyBlip);
		}
		
		public var s2:FlxText;
		public function TryMoveBox(dir:int):void
		{
			var tpx:int=this.box.px;
			var tpy:int=this.box.py;
			switch(dir)
			{
				case FlxSprite.UP:
					tpy--;
					break;
				case FlxSprite.DOWN:
					tpy++;
					break;
				case FlxSprite.LEFT:
					tpx--;
					break;
				case FlxSprite.RIGHT:
					tpx++;
					break;
			}
			
			if (!validcoord(tpx,tpy) || box.dat[tpx][tpy]!=1)
			{
				return;
			}
			else
			{
				var ix:int;
				var iy:int;
				
				ix=tpx-1;
				iy=tpy;
				if (validcoord(ix,iy))
				{				
					if (box.dat[ix][iy]!=2)
					{
						box.dat[ix][iy]=1-box.dat[ix][iy];
					}
				}
				ix=tpx+1;
				iy=tpy;
				if (validcoord(ix,iy))
				{						
					if (box.dat[ix][iy]!=2)
					{
						box.dat[ix][iy]=1-box.dat[ix][iy];
					}
				}
				ix=tpx;
				iy=tpy-1;
				if (validcoord(ix,iy))
				{				
					if (box.dat[ix][iy]!=2)
					{
						box.dat[ix][iy]=1-box.dat[ix][iy];
					}
				}
				ix=tpx;
				iy=tpy+1;
				if (validcoord(ix,iy))
				{					
					if (box.dat[ix][iy]!=2)
					{
						box.dat[ix][iy]=1-box.dat[ix][iy];
					}
				}
					
					
				box.px=tpx;
				box.py=tpy;
				
				this.generateBoxGraphics();
				if (tpx==box.ex && tpy==box.ey)
				{
					won=true;
					t=1;
					player.visible=false;
					end.flicker(1);
					FlxG.play(TitleState.SndLightBlip);
				}
				else
				{					
					FlxG.play(TitleState.SndNoiseBlip);
				}
			}
			
			FlxG.score++;
			scoretext.text = "moves : "+FlxG.score.toString();
			
		}
		
		private function validcoord(px:int,py:int):Boolean
		{
			return !(px<0 || px>=size || py<0 || py>=size);
		}
			
	}
	
	

}

import org.flixel.*;
class Box {
	public var s : int;
	public var dat : Vector.<Vector.<int>>;
	public var px:int;
	public var py:int;
	public var ex:int;
	public var ey:int;
	
	public function Box(_s:int)
	{
		var levelstr:String;
		switch (FlxG.level)
		{
			case 0:
				levelstr = new GameState.TxtLevel1();
				break;
			case 1:
				levelstr = new GameState.TxtLevel2();
				break;
			case 2:
				levelstr = new GameState.TxtLevel3();
				break;
			case 3:
				levelstr = new GameState.TxtLevel4();
				break;
			case 4:
				levelstr = new GameState.TxtLevel5();
				break;
			case 5:
				levelstr = new GameState.TxtLevel6();
				break;
			case 6:
				levelstr = new GameState.TxtLevel7();
				break;
			case 7:
				levelstr = new GameState.TxtLevel8();
				break;
			case 8:
				levelstr = new GameState.TxtLevel9();
				break;
			case 9:
				levelstr = new GameState.TxtLevel10();
				break;
		}
		var levelarr:Array = levelstr.split("\n");
		s=_s;
		dat = new Vector.<Vector.<int>>;
		
		for (var i:int =0;i<s;i++)
		{
			var v :Vector.<int> = new Vector.<int>;
			for (var j:int=0;j<s;j++)
			{
				switch(levelarr[i].charAt(j))
				{
					case "0":
						v.push(0);
						break;
					case "1":
						v.push(1);
						break;
					case " ":
						v.push(2);
						break;
					case "S":
					case "s":
						v.push(1);
						px=i;
						py=j;
						break;
					case "x":
						ex=i;
						ey=j;
						v.push(0);
						break;
					case "X":
						ex=i;
						ey=j;
						v.push(1);
						break;
				}
			}
			dat.push(v);
		}		
	}
}